"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.isStepInSubgraph = exports.listenFolderChangeCb = void 0;
const CommonOperations = __importStar(require("./CommonOperations"));
const State = __importStar(require("./State"));
// cb passed into useListenFirebase
const listenFolderChangeCb = (change, dispatch) => {
    const { doc, type } = change;
    if (type === 'clear') {
        dispatch({ type: State.getClearAllEntityActionString(CommonOperations.ECollectionRefs.folders) });
    }
    else if (type === 'added') {
        dispatch(State.getAddFolderAction(doc.id, doc.data()));
    }
    else if (type === "modified") {
        dispatch(State.getUpdateFolderAction(doc.id, doc.data()));
    }
    else if (type === "removed") {
        dispatch(State.getDeleteFolderAction(doc.id));
    }
    else {
        console.log("unknown update type", type);
        console.assert(false);
    }
};
exports.listenFolderChangeCb = listenFolderChangeCb;
const isStepInSubgraph = (subgraphCounter, allSubgraphs, stepCounter) => {
    if (!subgraphCounter) {
        return true; // default to true when there is no current subgraph
    }
    return !!subgraphCounter && allSubgraphs[subgraphCounter].steps.map(s => s.toString()).includes(stepCounter.toString());
};
exports.isStepInSubgraph = isStepInSubgraph;
//# sourceMappingURL=FolderOperations.js.map