"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.runHandler = exports.processMaterializationString = exports.executeInContext = void 0;
const Esprima = __importStar(require("esprima"));
const executeInContext = (code, context) => __awaiter(void 0, void 0, void 0, function* () {
    /*
    console.log("in execute")
    const isolate = new ivm.Isolate({ memoryLimit: 8 });
    const context = await isolate.createContext()

    const jail = context.global;

    // This make the global object available in the context as `global`. We use `derefInto()` here
    // because otherwise `global` would actually be a Reference{} object in the new isolate.
    jail.setSync('global', jail.derefInto());
    //add logger
    const logCallback = function (...args) {
        console.log(...args);
    };
    context.evalClosureSync(`global.log = function(...args) {
        $0.applyIgnored(undefined, args, { arguments: { copy: true } });
    }`, [logCallback], { arguments: { reference: true } });
    console.log("set log")
    Object.keys(c).forEach((k) => {
        context.evalClosureSync(`global.${k}= function(...args) {
        $0.applyIgnored(undefined, args, { arguments: { copy: false} });
    }`, [c[k]], { arguments: { reference: true } });
    })
    console.log("set c")
    const result = await context.evalClosure(`${code}`,
        [], { arguments: { reference: true } })
    return result;
    */
    Esprima.parseScript(`${code}
    `, { loc: true });
    return Function(...Object.keys(context), `return ${code}`)(...Object.values(context));
});
exports.executeInContext = executeInContext;
const processMaterializationString = (materializationCode) => __awaiter(void 0, void 0, void 0, function* () {
    let handlers = {};
    let docString = '';
    const getMaterializationContext = () => {
        return {
            registerMaterialization: (docs, handlerDict) => {
                console.log("in register MATERIALIZATION", docs, handlerDict);
                docString = docs;
                handlers = handlerDict;
            },
            RunSQL: (sql) => {
            }
        };
    };
    const context = getMaterializationContext();
    try {
        yield (0, exports.executeInContext)(materializationCode, context);
    }
    catch (ex) {
        console.log("got error", ex);
        return {
            error: ex
        };
    }
    return { docString, handlers };
});
exports.processMaterializationString = processMaterializationString;
const runHandler = (userConfig, selectSQL, f, getFullModelNameFunc) => __awaiter(void 0, void 0, void 0, function* () {
    return new Promise((resolve, reject) => __awaiter(void 0, void 0, void 0, function* () {
        const getFullModelName = () => {
            return getFullModelNameFunc();
            return `${userConfig.snowflakeWarehouse}`;
        };
        const handlerContext = {
            config: userConfig.config,
            getFullModelName,
            getSelectColumns: () => __awaiter(void 0, void 0, void 0, function* () {
                //const queryResult =await Snowflake.runSnowflakeQuery(userConfig, `${selectSQL} LIMIT 100`)
                //return queryResult.fields;
            }),
            RunSQL: (sql) => __awaiter(void 0, void 0, void 0, function* () {
                console.log("in execute sql", sql);
                /*return await runSnowflakeQuery(userConfig, sql).then((result) => {
                    console.log("got result", result)
                    return result
                })
                */
            })
        };
        try {
            const ret = yield f(selectSQL, handlerContext);
            if (typeof ret == 'string') {
                /*
                return runSnowflakeQuery(userConfig, ret).then((result) => {
                    console.log("HANDLER RESULT", result)
                    result.sql = ret
                    resolve(result)
                    return result;
                }).catch(reject)
                */
            }
            else {
                return ret;
            }
        }
        catch (ex) {
            console.error("failed in handler", f);
            reject(ex);
        }
    }));
});
exports.runHandler = runHandler;
//# sourceMappingURL=Materialization.js.map