"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RunNodeNameTest = exports.GetNewNodePrefix = exports.GetAllTestStepsData = exports.GetDefaultStepTypesParsed = void 0;
const StepTypes = __importStar(require("./StepTypes"));
const Runner = __importStar(require("./Runner"));
const StepOperations = __importStar(require("./StepOperations"));
const GetDefaultStepTypesParsed = () => {
    const defaultStepTypes = StepTypes.getDefaultStepTypes();
    const defaultStepTypesParsed = {};
    Object.keys(defaultStepTypes).forEach(sqlType => {
        defaultStepTypesParsed[sqlType] = StepTypes.parseStepTypeYAML(defaultStepTypes, sqlType);
    });
    return defaultStepTypesParsed;
};
exports.GetDefaultStepTypesParsed = GetDefaultStepTypesParsed;
const GetAllTestStepsData = () => {
    return AllStepData;
};
exports.GetAllTestStepsData = GetAllTestStepsData;
const GetNewNodePrefix = (sqlType) => {
    const defaultStepTypes = (0, exports.GetDefaultStepTypesParsed)();
    const nodeSpec = StepTypes.getNodeSpecSafe(defaultStepTypes, sqlType);
    return nodeSpec.short;
};
exports.GetNewNodePrefix = GetNewNodePrefix;
const AllStepData = {
    1: { operation: Object.assign(Object.assign({}, new Runner.SourceOperation()), { name: "MY_SOURCE_NODE" }) },
    2: { operation: Object.assign(Object.assign({}, new Runner.SQLOperation()), { name: "STG_CUSTOMER_TABLE", sqlType: Runner.ESQLType.stage }) },
    3: { operation: Object.assign(Object.assign({}, new Runner.SQLOperation()), { name: "STG_MYNODE_STG_GREG", sqlType: Runner.ESQLType.stage }) },
    4: { operation: Object.assign(Object.assign({}, new Runner.SQLOperation()), { name: "XSTG_MYNODE_STG_GREG", sqlType: Runner.ESQLType.stage }) },
    5: { operation: Object.assign(Object.assign({}, new Runner.SQLOperation()), { name: "STG_DIM_MY_NODE", sqlType: Runner.ESQLType.dimension }) },
    6: { operation: Object.assign(Object.assign({}, new Runner.SQLOperation()), { name: "STG_CUSTOMER", sqlType: Runner.ESQLType.stage }) },
    7: { operation: Object.assign(Object.assign({}, new Runner.SQLOperation()), { name: "STG_CUSTOMER_DATA", sqlType: Runner.ESQLType.stage }) }
};
const RunNodeNameTest = (sqlType, stepCounters) => {
    return StepOperations.getNewNodeName(sqlType, stepCounters, (0, exports.GetAllTestStepsData)(), (0, exports.GetDefaultStepTypesParsed)());
};
exports.RunNodeNameTest = RunNodeNameTest;
//# sourceMappingURL=NodeNamingTestUtil.js.map