"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.IsVersionURL = exports.GetValidURLFromVersion = exports.GetVersionCommitOrBranch = exports.listenPackageChangeCb = exports.EPackageStatus = exports.EntityAvailabilityForPackageImport = void 0;
const CommonOperations = __importStar(require("./CommonOperations"));
const State = __importStar(require("./State"));
const Common = __importStar(require("./Common"));
const Logging = __importStar(require("./Logging"));
const LogPackageOps = Logging.GetLogger(Logging.LoggingArea.Packages);
exports.EntityAvailabilityForPackageImport = {
    macros: true,
    stepTypes: true,
    folders: false,
    jobs: false,
    workspaces: false,
    locations: false,
    steps: false
};
var EPackageStatus;
(function (EPackageStatus) {
    EPackageStatus["adding"] = "adding";
    EPackageStatus["added"] = "added";
    EPackageStatus["removing"] = "removing";
    EPackageStatus["error"] = "error";
})(EPackageStatus = exports.EPackageStatus || (exports.EPackageStatus = {}));
// cb passed into useListenFirebase
const listenPackageChangeCb = (change, dispatch) => {
    const { doc, type } = change;
    if (type === "clear") {
        dispatch({ type: State.getClearAllEntityActionString(CommonOperations.ECollectionRefs.packages) });
    }
    else if (type === "added") {
        dispatch(State.getAddPackageAction(doc.id, doc.data()));
    }
    else if (type === "modified") {
        dispatch(State.getUpdatePackageAction(doc.id, doc.data()));
    }
    else if (type === "removed") {
        dispatch(State.getDeletePackageAction(doc.id));
    }
    else {
        const message = `Unknown update type ${type}`;
        LogPackageOps.error(message);
        Common.assert(Logging.LoggingArea.Packages, false, message);
    }
};
exports.listenPackageChangeCb = listenPackageChangeCb;
const GetVersionCommitOrBranch = (packageVersion) => {
    const indexOfHash = packageVersion.indexOf("#");
    if (indexOfHash > -1) {
        return packageVersion.slice(indexOfHash + 1);
    }
};
exports.GetVersionCommitOrBranch = GetVersionCommitOrBranch;
const GetValidURLFromVersion = (packageVersion) => {
    const indexOfHash = packageVersion.indexOf("#");
    if (indexOfHash > -1) {
        return packageVersion.slice(0, indexOfHash);
    }
    else {
        return packageVersion;
    }
};
exports.GetValidURLFromVersion = GetValidURLFromVersion;
const IsVersionURL = (packageVersion) => {
    const httpIndex = packageVersion.indexOf("http");
    // if 0, then macthes likely URL beginning w/https, else likely dir path
    return httpIndex === 0;
};
exports.IsVersionURL = IsVersionURL;
//# sourceMappingURL=PackageOperations.js.map