"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var _a, _b;
Object.defineProperty(exports, "__esModule", { value: true });
exports.DataKeys = exports.SearchFilters = exports.PayloadType = exports.getColumnReferencesFromColumnMetadata = exports.getInvalidColumnReference = exports.ColumnReference = exports.GetColumnReferenceClassInstance = exports.SourceColumnReference = exports.GetEmptySourceColumnReference = exports.HasColumnWithCustomAttribute = exports.hasCustomAttribute = exports.HasColumnWithCondition = exports.getColumnsWithCondition = exports.isEligibleForSurrogateKey = exports.isChangeTracking = exports.isPrimaryBusinessKey = exports.isSurrogateKey = exports.isInSuccessors = exports.getTableLocation = exports.getInvalidTableLocation = exports.TableLocation = exports.parseNamesFromTableReference = exports.findColumnCounterGivenNameRef = exports.findStepCounterGivenNameRef = exports.useMapLookup = exports.createStepMap = exports.getUniquePredeccesors = exports.extractPredecessors = exports.getPredecessorsWithLevels = exports.getSuccessorsWithLevels = exports.getSuccessors = exports.populateBlankSourceColumnRefs = exports.createSourceColumnReference = exports.CreateNewColumnFromParentColumn = exports.useDebouncedModifyStep = exports.GenerateUniqueName = exports.CreateHashColumnMetadata = exports.scratchIDString = exports.listenStepChangeCb = exports.getNextColumnCounter = exports.CreateAllEligibleSteps = exports.copyCollection = exports.getNewNodeName = exports.GetUniqueName = exports.copyDoc = exports.isStepUserDefinedNodeType = exports.GetStepName = exports.InvalidStepCounter = exports.GetStepColumnsSafe = exports.GetStepDocumentFS = void 0;
exports.AreAllStepDependenciesUnchanged = exports.GetStepDependenciesObject = exports.GetStepIDByNameAndStorageLocation = exports.GenerateNoLinkRefsFromSQLRunResult = exports.FormatHashUpdate = exports.CheckIfNodeHasHashColumns = exports.CheckAndUpgradeHashMetadata = exports.GetCascaderOptions = exports.CreateUpdatesForColumnDeletions = exports.ColumnHasValidSourceColumnReference = exports.FindSourceColumnMatchByName = exports.BulkRemapAllSourceColumnsByName = exports.FindDependencyLoop = exports.GetStepsWithInvalidLocations = exports.useSaveGridStateInModelViewer = exports.PropagationType = exports.GetStepsWithoutScratchStep = exports.GetColumnMetadataFromStep = exports.HasDuplicateData = exports.GetDeriveChanges = exports.createStorageObjFromMetadataArray = exports.GetBadgeColorFromStatusString = exports.statusStrings = exports.checkIsStepRunning = exports.checkAreStepsRunning = exports.HandleSQLDependenciesChange = exports.AccumulateReferencesErrorMessage = exports.AccumulateReferencesForErrorMessage = exports.parseSourceOperation = exports.ERowType = exports.GenerateDependenciesFromSQLRunResult = exports.GetAllStepsExceptSuccessors = exports.getAllStepsExceptCurrentAndSuccessors = exports.GetAllStepNames = exports.removeEmptyFolders = exports.filterDataProvider = exports.tableNameFilterFunction = void 0;
const react_1 = require("react");
const react_redux_1 = require("react-redux");
const Firebase = __importStar(require("./Firebase"));
const State = __importStar(require("./State"));
const Runner = __importStar(require("./Runner"));
const Common = __importStar(require("./Common"));
const Steps = __importStar(require("./Steps"));
const MetadataOperations = __importStar(require("./MetadataOperations"));
const CommonOperations = __importStar(require("./CommonOperations"));
const Immer = __importStar(require("immer"));
const RunnerOperations = __importStar(require("./RunnerOperations"));
const GraphOperations = __importStar(require("./GraphOperations"));
const Logging = __importStar(require("./Logging"));
const StepTypes = __importStar(require("./StepTypes"));
const SQLExecutorCreators = __importStar(require("./SQLExecutorCreators"));
const MappingOperations = __importStar(require("./MappingOperations"));
const GetStepDocumentFS = (teamID, workspaceID, stepsDocRef, stepCounter) => {
    return CommonOperations.getCollectionRef(teamID, workspaceID, stepsDocRef).doc(stepCounter.toString());
};
exports.GetStepDocumentFS = GetStepDocumentFS;
const GetStepColumnsSafe = (stepData) => {
    return Common.getValueSafe(stepData, ["operation", "metadata", "columns"], []);
};
exports.GetStepColumnsSafe = GetStepColumnsSafe;
exports.InvalidStepCounter = "0";
const GetStepName = (stepData) => {
    var _c;
    if (!stepData) {
        return null; //empty sourceInputs dont get links to them
    }
    return ((_c = stepData.operation.name) === null || _c === void 0 ? void 0 : _c.length) ? stepData.operation.name : `<Unnamed ${stepData.stepCounter}>`;
};
exports.GetStepName = GetStepName;
const L = Logging.GetLogger(Logging.LoggingArea.Steps);
const MetadataOperationsLogger = Logging.GetLogger(Logging.LoggingArea.MetadataOperations);
const StorageLocationLogger = Logging.GetLogger(Logging.LoggingArea.StorageLocations);
/*
 * user-defined node types will all contain only digits as the sqlType; regex below checks for any non-digit character, func returns true if none is found
 * parseInt and isNaN returned unexpected results in certain edge cases, this method should be more resilient
 */
const isStepUserDefinedNodeType = (step) => {
    return !!!(step.operation.sqlType.toString()).match(new RegExp("\\D", "g"));
};
exports.isStepUserDefinedNodeType = isStepUserDefinedNodeType;
const copyDoc = (collection, fromDoc, toDoc) => __awaiter(void 0, void 0, void 0, function* () {
    // get reference to the document being copied
    const fromDocRef = Firebase.getFirestore().collection(collection).doc(fromDoc);
    // grab the data from the document being copied
    const fromDocData = yield fromDocRef.get()
        .then((doc) => doc.exists && doc.data())
        .catch((error) => {
        console.log("could not get from-document data!", error);
    });
    // set the data in the docuement being copied to
    if (fromDocData) {
        yield Firebase.getFirestore().collection(collection).doc(toDoc).set(Object.assign({}, fromDocData))
            .catch((error) => {
            console.log("could not copy data!", error);
        });
    }
});
exports.copyDoc = copyDoc;
const dontCopyThatFloppy = (collections, fromId, toId) => {
    const user = Firebase.getFirebaseAuth().currentUser;
    if (user !== null) {
        collections.forEach((collection) => {
            console.log("current collection", collection);
            (0, exports.copyCollection)(`orgs/${fromId}/${collection}`, `orgs/${toId}/${collection}`);
        });
    }
};
const GetUniqueName = (fullName, allSteps) => {
    let nameToCheck = fullName;
    let counter = 0;
    while (!Runner.isTableNameUnique(allSteps, nameToCheck)) {
        counter = counter + 1;
        nameToCheck = fullName + counter.toString();
    }
    if (counter == 0) {
        //was unique to begin with  return CUSTOMER
        return fullName;
    }
    else {
        //requires some editing, return CUSTOMER1
        return fullName + counter.toString();
    }
};
exports.GetUniqueName = GetUniqueName;
const getNewNodeName = (sqlType, stepCounters, allSteps, stepTypesParsed) => {
    const nodeSpec = StepTypes.getNodeSpecSafe(stepTypesParsed, sqlType);
    /**
     * CD-1667
     * Remove blind removal of prefixes, and make sure their value is what we expect before slicing it off
     */
    const currentNames = stepCounters.map((stepCounter) => {
        const fullName = (0, exports.GetStepName)(allSteps[stepCounter]);
        const splitName = fullName.split("_");
        //do the removal here
        const sqlType = allSteps[stepCounter].operation.sqlType;
        const shortName = StepTypes.getNodeSpecSafe(stepTypesParsed, sqlType).short;
        if (splitName[0] === shortName) {
            return splitName.slice(1).join("_");
        }
        else {
            return splitName.join("_");
        }
    });
    // when creating a blank node
    if (!currentNames.length) {
        const fullName = `${nodeSpec.short}_NODE`;
        return (0, exports.GetUniqueName)(fullName, allSteps);
    }
    else {
        const baseName = `${currentNames.join("_")}`;
        //full name has the prefix
        const fullName = `${nodeSpec.short}_${baseName}`;
        //name to check is something like STG_CUSTOMER, and if it isnt unique it becomes STG_CUSTOMER1
        return (0, exports.GetUniqueName)(fullName, allSteps);
    }
};
exports.getNewNodeName = getNewNodeName;
const copyCollection = (collectionFrom, collectionTo) => __awaiter(void 0, void 0, void 0, function* () {
    // grab the documents from the collection being copied
    Firebase.getFirestore().collection(collectionFrom).get()
        .then((querySnapshot) => {
        querySnapshot.forEach((doc) => {
            const data = doc.data();
            Firebase.getFirestore().collection(collectionTo).doc(doc.id)
                .set(Object.assign({}, data));
        });
    })
        .catch((error) => {
        console.log(error);
    });
});
exports.copyCollection = copyCollection;
const CreateAllEligibleSteps = (allSteps, stepsToFilter, dispatch, isPreview, runtimeParameters) => {
    const eligibleSteps = [];
    stepsToFilter.forEach(stepCounter => {
        if ((stepCounter.toString() in allSteps) && !(allSteps[stepCounter].operation.type === Runner.EStepTypes.sourceInput)) {
            eligibleSteps.push(stepCounter);
        }
    });
    const RunSQL = SQLExecutorCreators.CreateRunSQLWithScheduler(null);
    return dispatch(Runner.PlayTaskThunk(false, eligibleSteps, null, RunnerOperations.OperationTypes.create, RunSQL, isPreview, runtimeParameters));
};
exports.CreateAllEligibleSteps = CreateAllEligibleSteps;
const getNextColumnCounter = (increment, teamID) => {
    // return getNextCounter(getDocumentRef(teamID, workspaceID, "steps").doc(stepCounter.toString()), 'columnCounter', increment)
    const firestore = Firebase.getFirestore();
    return CommonOperations.getNextCounter(firestore, CommonOperations.getOrgConfigDocRef(teamID), "columnCounter", increment);
};
exports.getNextColumnCounter = getNextColumnCounter;
// cb used for listening to step changes - passed into useListenFirebase
const listenStepChangeCb = (change, dispatch) => {
    const { type, doc } = change;
    if (type === "clear") {
        dispatch({ type: State.getClearAllEntityActionString(CommonOperations.ECollectionRefs.steps) });
        return;
    }
    const stepID = doc.id;
    if (type === "added") {
        dispatch(State.getCreateStepAction(doc.data(), 1, stepID, "", true, 0, 0));
    }
    else if (type === "modified") {
        dispatch(State.getUpdateStepDataAction(stepID, doc.data()));
    }
    else if (type === "removed") {
        dispatch(State.getRemoveStepAction(stepID, 1));
    }
    else {
        console.log("unknown update type", type);
        console.assert(false);
    }
};
exports.listenStepChangeCb = listenStepChangeCb;
exports.scratchIDString = "scratch";
// Automate some basic details for creating a hash
const CreateHashColumnMetadata = (hashedColumnRefs, refCount) => {
    const hashData = {
        hashAlgorithm: Runner.EHashAlgorithms.sha1,
    };
    const newColumn = Runner.getDefaultColumn();
    newColumn.sourceColumnReferences = (0, exports.populateBlankSourceColumnRefs)(refCount);
    newColumn.hashDetails = hashData;
    newColumn.nullable = true;
    newColumn.dataType = "STRING";
    newColumn.hashedColumns = hashedColumnRefs;
    return newColumn;
};
exports.CreateHashColumnMetadata = CreateHashColumnMetadata;
const GenerateUniqueName = (baseName, names) => {
    let counter = 1;
    const nameSet = new Set([...names]);
    //baseCase, first time the name is being used
    if (!nameSet.has(baseName))
        return baseName;
    //otherwise, iterate until you find a unique value
    while (nameSet.has(baseName + counter)) {
        counter++;
    }
    return baseName + counter;
};
exports.GenerateUniqueName = GenerateUniqueName;
const useDebouncedModifyStep = () => {
    //https://gist.github.com/zwily/40f32f7b480e2bad9249b72a1e5b2e85
};
exports.useDebouncedModifyStep = useDebouncedModifyStep;
/**
 * Helper function that maps specific columns from a parent column to a new column
 * @param parentColumn
 * @returns Runner.ColumnMetadata: A new column for a node, with some inherited values
 */
const CreateNewColumnFromParentColumn = (parentColumn) => {
    return {
        name: Common.getValueSafe(parentColumn, ['name'], 'NEW_COLUMN'),
        nullable: true,
        columnReference: { stepCounter: "0", columnCounter: 0 },
        sourceColumnReferences: [],
        description: '',
        defaultValue: '',
        hashColumns: [],
        hashDetails: null,
        dataType: Common.getValueSafe(parentColumn, ['dataType'], CommonOperations.EDataType.TEXT),
        config: {},
        appliedColumnTests: {},
        acceptedValues: { strictMatch: true, values: [] }
    };
};
exports.CreateNewColumnFromParentColumn = CreateNewColumnFromParentColumn;
const createSourceColumnReference = (column) => {
    const sourceColumnReference = {
        columnReferences: [column.columnReference],
        transform: ""
    };
    return sourceColumnReference;
};
exports.createSourceColumnReference = createSourceColumnReference;
const populateBlankSourceColumnRefs = (amountToPopulate) => {
    return new Array(amountToPopulate).fill({ transform: "", columnReferences: [] });
};
exports.populateBlankSourceColumnRefs = populateBlankSourceColumnRefs;
//given a step, this function determines which nodes/steps in the graph are connected downstream to it
const getSuccessors = (gFinal, stepCounter) => {
    const successorsWithLevels = (0, exports.getSuccessorsWithLevels)(gFinal, stepCounter);
    const successors = [];
    Object.values(successorsWithLevels).forEach(levelArray => {
        successors.push(...Array.from(levelArray));
    });
    return successors;
};
exports.getSuccessors = getSuccessors;
/*
 * returns successors in this format
 * {1: first 1 successors (Set), 2: second level successors, ...}
 */
const getSuccessorsWithLevels = (gFinal, parentCounter) => {
    const successors = {};
    const processNode = (stepCounter, level) => {
        const thisP = gFinal.successors(stepCounter);
        if (thisP) {
            thisP.forEach((singleP) => {
                if (!successors[level]) {
                    successors[level] = new Set();
                }
                successors[level].add(singleP);
                processNode(singleP, level + 1);
            });
        }
    };
    processNode(parentCounter, 1);
    return successors;
};
exports.getSuccessorsWithLevels = getSuccessorsWithLevels;
const getPredecessorsWithLevels = (gFinal, parentCounter) => {
    const predecessors = {};
    const processNode = (stepCounter, level) => {
        const thisP = gFinal.predecessors(stepCounter);
        if (thisP) {
            thisP.forEach((singleP) => {
                if (!predecessors[level]) {
                    predecessors[level] = new Set();
                }
                predecessors[level].add(singleP);
                processNode(singleP, level + 1);
            });
        }
    };
    processNode(parentCounter, 1);
    return predecessors;
};
exports.getPredecessorsWithLevels = getPredecessorsWithLevels;
//returns an array of all the sourceStepCounters and then sorts them
const extractPredecessors = (stepDataColumns, index) => {
    const hasSpecifiedIndex = !(index === null);
    let allStepCounters = [];
    stepDataColumns.forEach(column => {
        let sourceStepCounters = [];
        if (!hasSpecifiedIndex) {
            sourceStepCounters = MetadataOperations.getSourceStepCountersFromColumnMetadata(column);
        }
        else {
            const sourceColumnRef = MetadataOperations.getSourceColumnRef(column, index);
            sourceStepCounters = sourceColumnRef.getSourceStepCounters();
        }
        allStepCounters.push(...sourceStepCounters);
    });
    return allStepCounters.filter(v => v != exports.InvalidStepCounter);
};
exports.extractPredecessors = extractPredecessors;
const getUniquePredeccesors = (stepDataColumns, index) => {
    const duplicatePredecessors = (0, exports.extractPredecessors)(stepDataColumns, index);
    return Object.keys(duplicatePredecessors.reduce((accum, dependency) => {
        return Object.assign(Object.assign({}, accum), { [dependency]: 1 });
    }, {}));
};
exports.getUniquePredeccesors = getUniquePredeccesors;
//takes the current Step state and reduces it into a new object which excludes the provided stepCounter and its successors in the graph
const createStepMap = (stepCounter, allSteps, gFinal) => {
    const createMap = (stepCounter, allSteps) => {
        const map = Object.keys(allSteps).reduce((accum, key) => {
            //make sure not to include the current Step in the mapping
            if (key === stepCounter) {
                return accum;
            }
            const step = allSteps[key];
            let name = (0, exports.GetStepName)(step);
            //update the map with the new key pair
            return Object.assign(Object.assign({}, accum), { [key]: name });
        }, {});
        return map;
    };
    const memoSuccessors = (0, exports.getSuccessors)(gFinal, stepCounter);
    const map = createMap(stepCounter, allSteps);
    memoSuccessors.forEach(step => {
        delete map[step];
    });
    return map;
};
exports.createStepMap = createStepMap;
const useMapLookup = () => {
    //used to lookup a value from a mapping
    const lookupValue = (0, react_1.useCallback)((mapping, key) => {
        let value = "";
        value = mapping[key] !== undefined ? mapping[key] : `Unknown ${key}`;
        if (!key)
            value = "";
        return value;
    }, []);
    //used to find a key from a value in the mapping
    const lookupKey = (0, react_1.useCallback)((mapping, name) => {
        const keys = Object.keys(mapping);
        for (let i = 0; i < keys.length; i++) {
            let key = keys[i];
            if (mapping[key] === name)
                return key;
        }
    }, []);
    return { lookupValue, lookupKey };
};
exports.useMapLookup = useMapLookup;
const findStepCounterGivenNameRef = (allStepData, searchData, tableRef) => {
    const { tableName } = (0, exports.parseNamesFromTableReference)(tableRef);
    const stepCounter = searchData.find(stepCounter => {
        const step = allStepData[stepCounter];
        if (!step)
            return false;
        return step.operation.name === tableName;
    });
    return stepCounter !== undefined ? stepCounter : exports.InvalidStepCounter;
};
exports.findStepCounterGivenNameRef = findStepCounterGivenNameRef;
const findColumnCounterGivenNameRef = (allStepData, stepRef, columnName) => {
    const stepToSearch = allStepData[stepRef];
    let columnRef = 0;
    const columnObj = stepToSearch === null || stepToSearch === void 0 ? void 0 : stepToSearch.operation.metadata.columns.find(column => column.name === columnName);
    columnRef = (columnObj === null || columnObj === void 0 ? void 0 : columnObj.columnReference.columnCounter) || -1; //-1 to denote missing link
    return columnRef;
};
exports.findColumnCounterGivenNameRef = findColumnCounterGivenNameRef;
const parseNamesFromTableReference = (reference) => {
    let tableName = reference[0];
    const columnName = reference[1];
    return { tableName, columnName };
};
exports.parseNamesFromTableReference = parseNamesFromTableReference;
class TableLocation {
    constructor(database, schema, tableName) {
        this.isValid = () => {
            console.assert((!!this.schema) == (!!this.tableName));
            return !!this.tableName;
        };
        this.toString = () => {
            console.assert(!!this.isValid());
            return `${this.database}.${this.schema}.${this.tableName}`;
        };
        this.database = database;
        this.schema = schema;
        this.tableName = tableName;
    }
}
exports.TableLocation = TableLocation;
const getInvalidTableLocation = () => {
    return new TableLocation("", "", "");
};
exports.getInvalidTableLocation = getInvalidTableLocation;
const getTableLocation = (mappings, stepData, environmentID) => {
    // add handling for steps that have been deleted
    if (!stepData) {
        console.log("Step data no longer exists - getTableLocation");
        return (0, exports.getInvalidTableLocation)();
    }
    else {
        const locationName = stepData.locationName;
        const location = Common.getValueSafe(mappings, [locationName, environmentID], MappingOperations.GetEmptyDatabaseAndSchemaObject());
        return new TableLocation(location.database, location.schema, stepData.name);
    }
};
exports.getTableLocation = getTableLocation;
const isInSuccessors = (gFinal, currentStep, stepCounter) => {
    const successors = new Set((0, exports.getSuccessors)(gFinal, currentStep));
    return successors.has(stepCounter.toString());
};
exports.isInSuccessors = isInSuccessors;
/////////// Column Conditionals
const isSurrogateKey = (column) => !!column.isSurrogateKey;
exports.isSurrogateKey = isSurrogateKey;
const isPrimaryBusinessKey = (column) => !!column.isBusinessKey;
exports.isPrimaryBusinessKey = isPrimaryBusinessKey;
const isChangeTracking = (column) => !!column.isChangeTracking;
exports.isChangeTracking = isChangeTracking;
const isEligibleForSurrogateKey = (column) => !column.isSurrogateKey;
exports.isEligibleForSurrogateKey = isEligibleForSurrogateKey;
const getColumnsWithCondition = (columns, conditionCb) => {
    var _c;
    return (_c = columns.filter(column => conditionCb(column))) !== null && _c !== void 0 ? _c : null;
};
exports.getColumnsWithCondition = getColumnsWithCondition;
const HasColumnWithCondition = (columnArray, conditionCb) => {
    for (let i = 0; i < columnArray.length; i++) {
        if (conditionCb(columnArray[i])) {
            return true;
        }
    }
    return false;
};
exports.HasColumnWithCondition = HasColumnWithCondition;
const hasCustomAttribute = (column, attributeName) => {
    return !!Common.getValueSafe(column, ["config", attributeName], false);
};
exports.hasCustomAttribute = hasCustomAttribute;
const HasColumnWithCustomAttribute = (columnArray, attributeName) => {
    return (0, exports.HasColumnWithCondition)(columnArray, (column) => (0, exports.hasCustomAttribute)(column, attributeName));
};
exports.HasColumnWithCustomAttribute = HasColumnWithCustomAttribute;
const GetEmptySourceColumnReference = () => {
    return {
        columnReferences: [],
        transform: ""
    };
};
exports.GetEmptySourceColumnReference = GetEmptySourceColumnReference;
class SourceColumnReference {
    constructor(columnReferences, transform) {
        this[_a] = true;
        this.isValid = () => {
            return !!this.columnReferences.length || !!this.transform.length;
        };
        this.getTransform = () => {
            return this.transform;
        };
        this.getSourceStepCounters = () => {
            if (!this.isValid()) {
                return ["0"];
            }
            return this.columnReferences.map(ref => ref.stepCounter);
        };
        this.getSourceColumnLocation = (index) => {
            if (!this.isValid() || !this.columnReferences[index]) {
                return (0, exports.getInvalidColumnReference)();
            }
            const columnRef = this.columnReferences[index];
            return new ColumnReference(columnRef.stepCounter, columnRef.columnCounter);
        };
        this.toString = (allSteps, index) => {
            if (!this.isValid()) {
                return this.transform;
            }
            if (this.transform) {
                return this.transform;
            }
            const { stepCounter, columnCounter } = this.columnReferences[index];
            const columnRef = new ColumnReference(stepCounter, columnCounter);
            return columnRef.getQualifiedName(allSteps, "");
        };
        this.columnReferences = columnReferences;
        this.columnReferences.forEach((c) => {
            if (typeof c.stepCounter !== "string") {
                // all source step counters should be converted to strings by the steps reducer
                L.errorContext(Logging.frontEndGlobalContext, `Invalid type for source column reference step counter`);
            }
        });
        this.transform = transform;
    }
}
exports.SourceColumnReference = SourceColumnReference;
_a = Immer.immerable;
const GetColumnReferenceClassInstance = (columnReference) => {
    return new ColumnReference(columnReference.stepCounter, columnReference.columnCounter);
};
exports.GetColumnReferenceClassInstance = GetColumnReferenceClassInstance;
class ColumnReference {
    constructor(stepCounter, columnCounter) {
        this[_b] = true;
        this.isValid = (allSteps) => {
            console.assert((!!this.stepCounter) == (!!this.columnCounter));
            return !!this.stepCounter && !!this.hasValidReferences(allSteps);
        };
        this.hasValidReferences = (allSteps) => {
            return !!this.getColumnMetadata(allSteps);
        };
        this.getTableLocation = (locations, stepData, environmentID) => {
            console.assert(!!stepData);
            return (0, exports.getTableLocation)(locations, stepData.operation, environmentID);
        };
        this.getColumnMetadata = (allSteps) => {
            const stepData = allSteps[this.stepCounter];
            if (!stepData) {
                console.log("reference no longer exists", this.stepCounter);
                return null;
            }
            else {
                const columnData = stepData.operation.metadata.columns.find(column => column.columnReference.columnCounter === this.columnCounter);
                return !columnData ? null : columnData;
            }
        };
        this.getColumnName = (allSteps, defaultName) => {
            if (!this.isValid(allSteps)) {
                return defaultName;
            }
            const columnMetadata = this.getColumnMetadata(allSteps);
            return columnMetadata.name;
        };
        this.getQualifiedName = (allSteps, defaultName) => {
            if (!this.isValid(allSteps)) {
                return defaultName;
            }
            const stepData = allSteps[this.stepCounter];
            const stepName = (0, exports.GetStepName)(stepData);
            const columnMetadata = this.getColumnMetadata(allSteps);
            return `${stepName}.${columnMetadata.name}`;
        };
        this.getNameWithTableLocation = (allSteps, locations, defaultName, environmentID) => {
            if (!this.isValid(allSteps)) {
                return defaultName;
            }
            const stepData = allSteps[this.stepCounter];
            const tableLocation = this.getTableLocation(locations, stepData, environmentID);
            const columnMetadata = this.getColumnMetadata(allSteps);
            return `${tableLocation.toString()}.${columnMetadata.name}`;
        };
        // firebase doesn't allow storing class instances, so we have to create a plain object using the data from the reference
        this.toJSON = () => {
            return {
                stepCounter: this.stepCounter,
                columnCounter: this.columnCounter
            };
        };
        this.stepCounter = stepCounter;
        this.columnCounter = columnCounter;
    }
}
exports.ColumnReference = ColumnReference;
_b = Immer.immerable;
const getInvalidColumnReference = () => {
    return new ColumnReference(exports.InvalidStepCounter, 0);
};
exports.getInvalidColumnReference = getInvalidColumnReference;
const getColumnReferencesFromColumnMetadata = (columnMetadata, stepCounter) => {
    console.assert(!!stepCounter);
    return columnMetadata.map(c => {
        return new ColumnReference(c.columnReference.stepCounter, c.columnReference.columnCounter);
    });
};
exports.getColumnReferencesFromColumnMetadata = getColumnReferencesFromColumnMetadata;
//add more?
var PayloadType;
(function (PayloadType) {
    PayloadType["column"] = "Column";
    PayloadType["step"] = "Step";
    PayloadType["folder"] = "Folder";
    PayloadType["job"] = "Job";
    // used just for the data type folders
    PayloadType["immutableFolder"] = "Immutable Folder";
    PayloadType["allNodesFolder"] = "All Nodes Folder";
    PayloadType["searchCategoryFolder"] = "Search Category Folder";
    PayloadType["allJobsFolder"] = "All Jobs Folder";
    PayloadType["allSubgraphsFolder"] = "All Subgraphs Folder";
})(PayloadType = exports.PayloadType || (exports.PayloadType = {}));
//helper functions for 
const checkStringsIncludes = (string1, string2) => {
    if (!string1 || !string2) {
        return false;
    }
    let lowerString1 = string1.toLowerCase();
    let lowerString2 = string2.toLowerCase();
    return lowerString1.includes(lowerString2);
};
const checkStringsPrefix = (string1, string2) => {
    let lowerString1 = string1.toLowerCase();
    let lowerString2 = string2.toLowerCase();
    return lowerString1.startsWith(lowerString2);
};
var SearchFilters;
(function (SearchFilters) {
    SearchFilters["table"] = "Table";
    SearchFilters["column"] = "Column";
    SearchFilters["description"] = "Description";
    SearchFilters["columnDescription"] = "CDescription";
    SearchFilters["transform"] = "Transform";
})(SearchFilters = exports.SearchFilters || (exports.SearchFilters = {}));
var DataKeys;
(function (DataKeys) {
    DataKeys["Column"] = "name";
    DataKeys["Description"] = "description";
    DataKeys["CDescription"] = "description";
    DataKeys["Transform"] = "transform";
})(DataKeys = exports.DataKeys || (exports.DataKeys = {}));
//need these to return an array of all the matching items to build the new StepRowData or maybe they just build it for free?
const tableNameFilterFunction = (searchValue, data, allData, tag) => {
    /*
     * const { value, stepCounter } = data;
     * if (!stepCounter) return [];
     */
    const nuData = Object.assign(Object.assign({}, data), { searchValue: searchValue });
    if (checkStringsIncludes(data.value, searchValue))
        return [nuData];
    return [];
};
exports.tableNameFilterFunction = tableNameFilterFunction;
const tableTagFilterFunction = (searchValue, data, allData, tag) => {
    const { stepCounter } = data;
    if (!stepCounter)
        return [];
    const stepData = allData[stepCounter];
    const tagValue = stepData.operation[DataKeys[tag]];
    let newData = { heirarchy: [...data.heirarchy, tag, stepData.operation[DataKeys[tag]]], type: PayloadType.step, stepCounter: stepCounter, searchValue: searchValue, key: CommonOperations.generateKey(["0"]) };
    if (checkStringsIncludes(tagValue, searchValue)) {
        newData["value"] = newData.heirarchy[newData.heirarchy.length - 1];
        return [newData];
    }
    return [];
};
const columnTagFilterFunction = (searchValue, data, allData, tag) => {
    const { stepCounter } = data;
    if (!stepCounter)
        return [];
    const newStepRowData = [];
    const stepData = allData[stepCounter];
    const columns = stepData === null || stepData === void 0 ? void 0 : stepData.operation.metadata.columns;
    columns.forEach(column => {
        if (checkStringsIncludes(column[DataKeys[tag]], searchValue)) {
            let newData = {
                heirarchy: [...data.heirarchy, tag, column[DataKeys[tag]]],
                type: PayloadType.column,
                value: column[DataKeys[tag]],
                stepCounter: stepCounter,
                columnCounter: column.columnCounter,
                searchValue: searchValue,
                key: CommonOperations.generateKey(["0", data.heirarchy[1], parseInt(data.heirarchy[2]), tag, column[DataKeys[tag]]])
            };
            newStepRowData.push(newData);
        }
    });
    return newStepRowData;
};
const filterDataProvider = (tag) => {
    switch (tag) {
        case SearchFilters.table:
            return exports.tableNameFilterFunction;
        case SearchFilters.description:
            return tableTagFilterFunction;
        case SearchFilters.column:
        case SearchFilters.columnDescription:
        case SearchFilters.transform:
            return columnTagFilterFunction;
        default:
            return () => [];
    }
};
exports.filterDataProvider = filterDataProvider;
const removeEmptyFolders = (rowData) => {
    const parentFolder = rowData[0];
    const steps = rowData.filter(row => row.type === PayloadType.step);
    const subgraphs = rowData.filter(row => row.type === PayloadType.folder);
    const folders = rowData.filter(row => row.type === PayloadType.immutableFolder);
    const jobs = rowData.filter(row => row.type === PayloadType.job);
    const foldersWithContents = folders.reduce((filledFolders, folder) => {
        steps.forEach(step => {
            if (step.key.includes(folder.key) && !filledFolders.includes(folder)) {
                const folderKeyLength = folder.key.length;
                const stepKeySubStr = step.key.substring(0, folderKeyLength);
                if (stepKeySubStr === folder.key) {
                    filledFolders.push(folder);
                }
            }
        });
        return filledFolders;
    }, []);
    const groomedData = [parentFolder, ...foldersWithContents, ...steps, ...subgraphs, ...jobs];
    return groomedData;
};
exports.removeEmptyFolders = removeEmptyFolders;
//needs to account for target name
const GetAllStepNames = (steps) => {
    const stepNames = new Set();
    Steps.forAllSteps(steps, (stepCounter, stepData) => {
        var _c;
        stepNames.add(stepData.operation.locationName + ((_c = stepData.operation.name) === null || _c === void 0 ? void 0 : _c.toLowerCase()));
    });
    return stepNames;
};
exports.GetAllStepNames = GetAllStepNames;
const getAllStepsExceptCurrentAndSuccessors = (currentStep, allSteps, gFinal) => {
    const output = (0, exports.GetAllStepsExceptSuccessors)(currentStep, allSteps, gFinal);
    delete output[currentStep];
    return output;
};
exports.getAllStepsExceptCurrentAndSuccessors = getAllStepsExceptCurrentAndSuccessors;
const GetAllStepsExceptSuccessors = (stepCounter, allSteps, gFinal) => {
    const createMap = (stepCounter, allSteps) => {
        const map = Object.keys(allSteps).reduce((accum, key) => {
            //make sure not to include the current Step in the mapping
            if (key === stepCounter) {
                return accum;
            }
            const step = allSteps[key];
            let name = (0, exports.GetStepName)(step);
            //update the map with the new key pair
            return Object.assign(Object.assign({}, accum), { [key]: name });
        }, {});
        return map;
    };
    const successors = (0, exports.getSuccessors)(gFinal, stepCounter);
    const map = createMap(stepCounter, allSteps);
    successors.forEach(step => {
        delete map[step];
    });
    return map;
};
exports.GetAllStepsExceptSuccessors = GetAllStepsExceptSuccessors;
const GenerateDependenciesFromSQLRunResult = (runResult) => {
    const refs = {};
    const { exported_refs } = runResult.runDetails;
    exported_refs.forEach(ref => {
        refs[`${ref.location_name}-${ref.node_name}`] = {
            locationName: ref.location_name,
            nodeName: ref.node_name
        };
    });
    const newDependencies = Object.values(refs).map(ref => {
        const { locationName, nodeName } = ref;
        return { locationName: locationName, nodeName: nodeName };
    });
    return newDependencies;
};
exports.GenerateDependenciesFromSQLRunResult = GenerateDependenciesFromSQLRunResult;
var ERowType;
(function (ERowType) {
    ERowType["database"] = "database";
    ERowType["dataset"] = "dataset";
    ERowType["table"] = "table";
})(ERowType = exports.ERowType || (exports.ERowType = {}));
const parseSourceOperation = (serializedSourceInfo) => {
    const { location, table, rowType } = serializedSourceInfo;
    Common.assert(Logging.LoggingArea.Steps, Common.isStringFreeOfProtectedCharacters(location), "(parseSourceOperation) invalid location name");
    Common.assert(Logging.LoggingArea.Steps, rowType === ERowType.table, `(parseSourceOperation) invalid row type: ${rowType}`);
    const sourceOp = new Runner.SourceOperation();
    const joinString = `FROM {{ ref('${location}', '${table}') }}`;
    return Object.assign(sourceOp, { locationName: location, table, name: table, metadata: { join: { joinCondition: joinString } } });
};
exports.parseSourceOperation = parseSourceOperation;
const AccumulateReferencesForErrorMessage = (message, references) => {
    return references.map((ref) => {
        return message + `Location: "${ref.locationName}", Node name: "${ref.nodeName}"`;
    });
};
exports.AccumulateReferencesForErrorMessage = AccumulateReferencesForErrorMessage;
const AccumulateReferencesErrorMessage = (unsafe, invalid, nonExistant) => {
    let messages = [];
    if (unsafe.length) { //Unsafe reference found. Use ref_no_link or remove: location: #, name: #
        let unsafeAlertMessage = "Unsafe reference found. Use ref_no_link or remove: ";
        const unsafeAlertMessages = (0, exports.AccumulateReferencesForErrorMessage)(unsafeAlertMessage, unsafe);
        messages.push(...unsafeAlertMessages);
    }
    if (invalid.length) { //Location {insert} is unknown
        const invalidMessages = invalid.map(ref => {
            return `Location not found. Location: '${ref.locationName}'`;
        });
        messages.push(...invalidMessages);
    }
    if (nonExistant.length) { //Reference not found.  Use ref_no_link if {insert} exists outside of metadata.
        const missingMessages = (0, exports.AccumulateReferencesForErrorMessage)("", nonExistant).map(message => {
            return `Reference not found.  Use ref_no_link or remove: ${message}`;
        });
        messages.push(...missingMessages);
    }
    return messages;
};
exports.AccumulateReferencesErrorMessage = AccumulateReferencesErrorMessage;
const HandleSQLDependenciesChange = (result, state, currentStep, aliasResult) => {
    const invalidRefs = result.runDetails.invalid_exported_refs.map(ref => {
        return { locationName: ref.location_name, nodeName: ref.node_name };
    });
    const newDependencies = (0, exports.GenerateDependenciesFromSQLRunResult)(result);
    const { stepCountersToAdd, nonExistentRefs } = GraphOperations.GetDependencyStepCountersAndNonExistentRefs(state.steps, newDependencies);
    const gFinal = state.edges.gFinal;
    const successors = new Set((0, exports.getSuccessors)(gFinal, currentStep));
    const safeDependencies = [];
    const unsafeDependencies = [];
    //split out safe and unsafe deps
    stepCountersToAdd.forEach(stepCounter => {
        const { locationName, name } = state.steps[stepCounter].operation;
        const ref = {
            locationName,
            nodeName: name,
        };
        if (!successors.has(stepCounter.toString()) && stepCounter.toString() !== currentStep.toString()) {
            safeDependencies.push(ref);
        }
        else {
            unsafeDependencies.push(ref);
        }
    });
    let errorMessages = (0, exports.AccumulateReferencesErrorMessage)(unsafeDependencies, invalidRefs, nonExistentRefs);
    return { newDependencies: safeDependencies, errorMessages: errorMessages };
};
exports.HandleSQLDependenciesChange = HandleSQLDependenciesChange;
const checkAreStepsRunning = (runResults, allSteps) => {
    return Object.keys(runResults).some(stepCounter => {
        // adding first check because we're persisting old run results for deleted steps
        return !!allSteps[stepCounter] && (0, exports.checkIsStepRunning)(runResults, (stepCounter));
    });
};
exports.checkAreStepsRunning = checkAreStepsRunning;
const checkIsStepRunning = (runResults, stepCounter) => {
    return runResults[stepCounter].runState === RunnerOperations.RunResultsRunState.running;
};
exports.checkIsStepRunning = checkIsStepRunning;
exports.statusStrings = {
    added: "added",
    removed: "removed",
    modified: "modified",
    unmodified: "unmodified"
};
const GetBadgeColorFromStatusString = (status) => {
    switch (status) {
        case exports.statusStrings.added:
            return "Green";
        case exports.statusStrings.removed:
            return "Red";
        case exports.statusStrings.modified:
            return "#ffc414";
        default:
            return "#353535";
    }
};
exports.GetBadgeColorFromStatusString = GetBadgeColorFromStatusString;
const pushDeriveObjToStatusArray = (name, oldData, newData, status, array) => {
    const newObj = {
        columnName: name,
        status: exports.statusStrings[status],
        oldData,
        newData
    };
    array.push(newObj);
};
const createStorageObjFromMetadataArray = (array) => {
    const outputObj = {};
    array.forEach((element) => {
        outputObj[element.name] = Object.assign({}, element);
    });
    return outputObj;
};
exports.createStorageObjFromMetadataArray = createStorageObjFromMetadataArray;
const GetDeriveChanges = (columns, newColumns) => {
    const output = {
        tableData: {
            added: [],
            modified: [],
            removed: [],
            unmodified: []
        },
        filteredColumns: []
    };
    const originalColumnStorage = (0, exports.createStorageObjFromMetadataArray)(columns);
    const tableArrays = output.tableData;
    newColumns.forEach((column) => {
        const colName = column.name;
        if (originalColumnStorage.hasOwnProperty(colName)) {
            const storageAtColumn = originalColumnStorage[colName];
            switch (column.dataType) {
                case storageAtColumn.dataType:
                    pushDeriveObjToStatusArray(colName, storageAtColumn, column, exports.statusStrings.unmodified, tableArrays.unmodified);
                    break;
                default:
                    pushDeriveObjToStatusArray(colName, Object.assign({}, storageAtColumn), column, exports.statusStrings.modified, tableArrays.modified);
                    storageAtColumn.dataType = column.dataType;
            }
            output.filteredColumns.push(storageAtColumn);
            delete originalColumnStorage[colName];
        }
        else {
            pushDeriveObjToStatusArray(colName, null, column, exports.statusStrings.added, tableArrays.added);
            output.filteredColumns.push(column);
        }
    });
    for (const column in originalColumnStorage) {
        pushDeriveObjToStatusArray(originalColumnStorage[column].name, originalColumnStorage[column], null, exports.statusStrings.removed, tableArrays.removed);
    }
    return output;
};
exports.GetDeriveChanges = GetDeriveChanges;
const HasDuplicateData = (arrayOfObjs, field) => {
    const tempStorage = {};
    return arrayOfObjs.some((column) => {
        if (tempStorage.hasOwnProperty(column[field])) {
            return true;
        }
        else {
            tempStorage[column[field]] = true;
            return false;
        }
    });
};
exports.HasDuplicateData = HasDuplicateData;
const GetColumnMetadataFromStep = (stepData, columnCounter, keyPath) => {
    const columns = Common.getValueSafe(stepData, ["operation", "metadata", "columns"], []);
    const targetColumn = columns.find(column => column.columnReference.columnCounter == columnCounter);
    const targetValue = Common.getValueSafe(targetColumn, keyPath, null);
    return targetValue;
};
exports.GetColumnMetadataFromStep = GetColumnMetadataFromStep;
const GetStepsWithoutScratchStep = (steps) => {
    const updatedSteps = Common.CreateDeepClone(steps);
    delete updatedSteps.scratch;
    return updatedSteps;
};
exports.GetStepsWithoutScratchStep = GetStepsWithoutScratchStep;
var PropagationType;
(function (PropagationType) {
    PropagationType["add"] = "Add";
    PropagationType["delete"] = "Delete";
    PropagationType["none"] = "None";
})(PropagationType = exports.PropagationType || (exports.PropagationType = {}));
const useSaveGridStateInModelViewer = (stepCounter, modelViewerKey) => {
    const dispatch = (0, react_redux_1.useDispatch)();
    const gridState = (0, react_redux_1.useSelector)(state => Common.getValueSafe(state, ["modelViewerState", stepCounter, modelViewerKey], {}));
    const updateGridState = (0, react_1.useCallback)((newColumnWidths) => {
        dispatch(State.changeModelViewerState(stepCounter, modelViewerKey, newColumnWidths));
    }, [dispatch, modelViewerKey, stepCounter]);
    return [gridState, updateGridState];
};
exports.useSaveGridStateInModelViewer = useSaveGridStateInModelViewer;
/**
 * Creates an array of error messages for steps with invalid locations
 */
const GetStepsWithInvalidLocations = (allWorkspaceData, workspaceIDDeployingTo) => {
    if (!allWorkspaceData.locations) {
        StorageLocationLogger.error("allWorkspaceData passed to GetStepsWithInvalidLocations (from git) missing locations");
        throw new Error("Workspace data from git has no storage locations and can't be used for deployment");
    }
    const physicalLocations = MappingOperations.GetPhysicalLocationsFromMappings(allWorkspaceData.locations, workspaceIDDeployingTo);
    const locationData = Object.keys(allWorkspaceData.locations).reduce((locObj, locationName) => {
        const thisLocation = physicalLocations[locationName];
        locObj[locationName] = { missingInfo: [] };
        // in case the location is available in workspace mappings, but the needed information is no longer filled out correctly for the environment
        if (!thisLocation || thisLocation.schema === "") {
            locObj[locationName].missingInfo.push("schema");
        }
        if (!thisLocation || thisLocation.database === "") {
            locObj[locationName].missingInfo.push("database");
        }
        return locObj;
    }, {});
    const stepDetails = Object.keys(allWorkspaceData.steps).map(stepID => {
        const step = allWorkspaceData.steps[stepID];
        const isSource = step.operation.type === Runner.EStepTypes.sourceInput;
        return { name: step.name, locationName: step.operation.locationName, isSource };
    });
    const stepsWithInvalidLocations = [];
    stepDetails.forEach(step => {
        // if step is source then return bc no schema/database
        if (step.isSource)
            return;
        // for when storage location is added w/o ever adding database/schema - location will never be added to workspace mappings
        if (!locationData[step.locationName]) {
            const errorString = `${step.name} is using an invalid storage location: "${step.locationName}"`;
            stepsWithInvalidLocations.push(errorString);
            return;
        }
        // this declaration/check must occur after the previous if check that protects against missing locations, else this will be undefined
        const stepLocationMissingInfo = locationData[step.locationName].missingInfo;
        if (!stepLocationMissingInfo.length)
            return;
        const errorString = `${step.name} is using storage location "${step.locationName}" which is not using a valid ${stepLocationMissingInfo.length > 1 ? `${stepLocationMissingInfo[0]} or ${stepLocationMissingInfo[1]}` : stepLocationMissingInfo[0]}.`;
        stepsWithInvalidLocations.push(errorString);
    });
    return stepsWithInvalidLocations;
};
exports.GetStepsWithInvalidLocations = GetStepsWithInvalidLocations;
/**
 * func for helping find a circular dependency loop - hits a debugger
 * if the passed step id has a downstream dependency that contains itself as a dependency.
 * you can then use the successorTree to trace back the ids of each step involved in the loop
 * @param stepCounterArg
 * @param gFinal
 */
const FindDependencyLoop = (stepCounterArg, gFinal) => {
    const parentStepCounter = stepCounterArg;
    let successorTree = {};
    const ProcessDependencies = (stepCounter) => {
        // get successors for stepCounter
        const successorIDs = gFinal.successors(stepCounter);
        // break out if a dependency has the first arg as a dependency
        if (successorIDs.includes(parentStepCounter)) {
            return;
        }
        if (successorIDs.length) {
            successorIDs.forEach(successor => {
                if (!successorTree[stepCounter]) {
                    successorTree[stepCounter] = {};
                }
                if (!successorTree[stepCounter][successor]) {
                    successorTree[stepCounter][successor] = {};
                }
                ProcessDependencies(successor);
            });
        }
    };
    ProcessDependencies(parentStepCounter);
};
exports.FindDependencyLoop = FindDependencyLoop;
/**
 *
 * @param sourceStepID the id of the node that you're trying to map to
 * @param targetStepID the id of the node that you're trying to update
 * @param multisourceIndex
 * @param allSteps
 * @returns
 */
const BulkRemapAllSourceColumnsByName = (sourceStepID, targetStepID, multisourceIndex, allSteps) => {
    const sourceStepColumns = MetadataOperations.getColumnsForStep(allSteps, sourceStepID);
    const targetStepColumns = MetadataOperations.getColumnsForStep(allSteps, targetStepID);
    Common.assert(Logging.LoggingArea.Steps, !!targetStepColumns, `Invalid mapping operation: corrupt target step ${targetStepID}`);
    Common.assert(Logging.LoggingArea.Steps, !!sourceStepColumns, `Invalid mapping operation: corrupt source step ${targetStepID}`);
    if (sourceStepID === targetStepID) {
        return {
            columnMetadata: targetStepColumns,
            errors: ["Preventing bulk remap, unable to map columns from same node"]
        };
    }
    else {
        let errors = [];
        // this will return the original column metadata if there's an existing value or if no match is found
        const newColumnsWithMapping = targetStepColumns.map(col => {
            // don't overwrite an existing value
            if ((0, exports.ColumnHasValidSourceColumnReference)(col, multisourceIndex)) {
                return col;
            }
            const columnMatchResult = (0, exports.FindSourceColumnMatchByName)(col, sourceStepColumns, multisourceIndex, allSteps);
            if (columnMatchResult === null) {
                // note: if a column does not have a sourceColumnReference[multisourceIndex], it will hit this code / related to CD-3414
                errors.push(`Error finding a valid source column match for ${col.name}`);
                return col;
            }
            return MetadataOperations.GetColumnWithUpdatedSourceColumnReference(col, multisourceIndex, columnMatchResult.columnReference);
        });
        return { columnMetadata: newColumnsWithMapping, errors };
    }
};
exports.BulkRemapAllSourceColumnsByName = BulkRemapAllSourceColumnsByName;
/**
 *
 * @param columnToUpdate
 * @param sourceColumnsToSearch
 * @param multisourceIndex
 * @param allSteps
 * @returns a column with a name that either matches the columnToUpdate's name or the columnToUpdate's
 * source column's name, or null if no match was found
 */
const FindSourceColumnMatchByName = (columnToUpdate, sourceColumnsToSearch, multisourceIndex, allSteps) => {
    var _c;
    let nameToCompare;
    if (!(0, exports.ColumnHasValidSourceColumnReference)(columnToUpdate, multisourceIndex)) {
        // if the passed column doesn't have a source column, match it to a source by its own name. 
        L.info("Column has no source column reference, mapping by name");
        nameToCompare = columnToUpdate.name;
    }
    else {
        // get the name of the current source column
        const sourceColumnRef = columnToUpdate.sourceColumnReferences[multisourceIndex];
        const columnReference = (0, exports.GetColumnReferenceClassInstance)(sourceColumnRef.columnReferences[0]);
        /**
         * "Unknown Column" is the default value that's returned in case there's an issue finding the source column's name.
         * If "Unknown Column" is the value we get back, just return early
         */
        nameToCompare = columnReference.getColumnName(allSteps, "Unknown Column");
        if (nameToCompare === "Unknown Column") {
            return null;
        }
    }
    return (_c = sourceColumnsToSearch.find(sourceColumn => nameToCompare === sourceColumn.name)) !== null && _c !== void 0 ? _c : null;
};
exports.FindSourceColumnMatchByName = FindSourceColumnMatchByName;
const ColumnHasValidSourceColumnReference = (column, multisourceIndex) => {
    Common.assert(Logging.LoggingArea.Steps, !!column.sourceColumnReferences, `ColumnHasValidSourceColumnReference: sourceColumns was falsy - sourceColumns: ${column.sourceColumnReferences}`);
    if (!column.sourceColumnReferences[multisourceIndex]) {
        L.error(`ColumnHasValidSourceColumnReference: missing sourceColumnReference at multisourceIndex ${multisourceIndex}, column metadata:`, column);
    }
    return !!Common.getValueSafe(column.sourceColumnReferences, [multisourceIndex, "columnReferences", 0], false);
};
exports.ColumnHasValidSourceColumnReference = ColumnHasValidSourceColumnReference;
/**
 * Helper function for the usePropagateColumnDeletion
 * Handles creating all the updates that get processed to firebase in the hook version
 * @param selectedColumnsForDeletion (in the context of the UI, these are the columns selected manually
 * by the user clicking checkboxes for deletion)
 * @param allSteps
 * @param sourceColumnsForPropagation (in the context of the UI, these are the columns that the user
 * highlighted when targeting columns to kick off the propagation menu)
 * @returns
 */
const CreateUpdatesForColumnDeletions = (selectedColumnsForDeletion, allSteps) => {
    const cleanColumns = Object.assign({}, selectedColumnsForDeletion);
    Object.keys(cleanColumns).forEach(columnReferenceString => {
        if (cleanColumns[columnReferenceString] === false) {
            delete cleanColumns[columnReferenceString];
        }
    });
    /*
     * shaped the updates
     * convert sourceColumnsForPropagation into string[] using key format outlined in SelectedColumnCollection
     */
    const ColumnCacheForUpdates = {};
    const cleanColumnKeys = Object.keys(cleanColumns);
    cleanColumnKeys.forEach(columnReferenceString => {
        //convert columnReferenceString to usable items
        const [stepCounter, columnCounter] = columnReferenceString.split(" ");
        let columns;
        if (!ColumnCacheForUpdates[stepCounter]) {
            columns = Common.getValueSafe(allSteps, [stepCounter, "operation", "metadata", "columns"], []);
        }
        else {
            columns = ColumnCacheForUpdates[stepCounter];
        }
        //look for current reference
        const targetIndex = columns.findIndex(column => column.columnReference.columnCounter === parseInt(columnCounter));
        //make copy
        let updatedColumns = columns;
        if (targetIndex !== -1) {
            const newColumns = updatedColumns.slice();
            //remove
            newColumns.splice(targetIndex, 1);
            updatedColumns = newColumns;
            //update the cache for the possible next column update from the same node
            ColumnCacheForUpdates[stepCounter] = updatedColumns;
        }
    });
    const updates = Object.keys(ColumnCacheForUpdates).map(stepCounter => {
        const updatedColumns = ColumnCacheForUpdates[stepCounter];
        return { stepCounter: stepCounter, key: "metadata.columns", value: updatedColumns };
    });
    return updates;
};
exports.CreateUpdatesForColumnDeletions = CreateUpdatesForColumnDeletions;
const SortCascaderOptions = (optionsToSort) => {
    optionsToSort.forEach(option => option.children.sort((a, b) => (a.label > b.label) ? 1 : -1));
    return optionsToSort.sort((a, b) => (a.label > b.label) ? 1 : -1);
};
const GetCascaderOptions = (stepCounter, allStepData, gFinal) => {
    const output = [];
    if (!gFinal || !allStepData) {
        return output;
    }
    const stepMap = (0, exports.GetAllStepsExceptSuccessors)(stepCounter, allStepData, gFinal);
    Steps.forAllSteps(allStepData, (stepCounter, stepData) => {
        if (stepMap.hasOwnProperty(stepCounter)) {
            const stepToAdd = {
                value: Number(stepCounter),
                label: stepData.operation.name,
                children: []
            };
            stepData.operation.metadata.columns.forEach((child) => {
                stepToAdd.children.push({
                    value: child.columnReference.columnCounter,
                    label: child.name
                });
            });
            output.push(stepToAdd);
        }
    });
    SortCascaderOptions(output);
    return output;
};
exports.GetCascaderOptions = GetCascaderOptions;
const CheckAndUpgradeHashMetadata = (allColumnMetadata) => {
    const nodeHasOldMetadata = allColumnMetadata.some(col => {
        var _c, _d;
        const hasHashColumns = !!col.hashColumns;
        const hasHashTypeOrHubHashes = !!((_c = col.hashDetails) === null || _c === void 0 ? void 0 : _c.hashType) || !!((_d = col.hashDetails) === null || _d === void 0 ? void 0 : _d.hubHashes);
        const hasNullHashDetails = col.hashDetails === null;
        return hasHashColumns || hasHashTypeOrHubHashes || hasNullHashDetails;
    });
    const AddHashedColumnToArray = (hashColumn, hashedColumnRef) => {
        /*
         * for some reason, deleted hash columns with the old metadata sometimes didn't clear out all references to them.
         * if they no longer exist, we can just ignore them and delete those obsolete references and continue
         */
        if (!hashColumn) {
            return;
        }
        else {
            if (!hashColumn.hashedColumns) {
                hashColumn.hashedColumns = [];
            }
            const hashedColumnCounterSet = new Set(hashColumn.hashedColumns.map(hashedCol => hashedCol.columnCounter));
            // if statement required to prevent duplicates that could get pushed if function called more than once on the same node
            if (!hashedColumnCounterSet.has(hashedColumnRef.columnCounter)) {
                hashColumn.hashedColumns.push(hashedColumnRef);
            }
        }
    };
    if (!nodeHasOldMetadata) {
        return allColumnMetadata;
    }
    else {
        allColumnMetadata.forEach(col => {
            var _c;
            if (col.hashColumns) {
                col.hashColumns.forEach(hashCol => {
                    const hashColumnToModify = allColumnMetadata.find(col => col.columnReference.columnCounter === hashCol.columnCounter);
                    AddHashedColumnToArray(hashColumnToModify, col.columnReference);
                });
                delete col.hashColumns;
            }
            if (col.hashDetails) {
                delete col.hashDetails.hashType;
                // hubHashes are stored on the link hash column themselves, inverse of how other hashed columns were stored in old system
                if ((_c = col.hashDetails.hubHashes) === null || _c === void 0 ? void 0 : _c.length) {
                    col.hashDetails.hubHashes.forEach(hubHashColRef => {
                        AddHashedColumnToArray(col, hubHashColRef);
                    });
                }
                delete col.hashDetails.hubHashes;
            }
            // this attribute existed on all columns w/ old metadata; if it's null, it's not a hash column, so we can just get rid of it
            if (col.hashDetails === null) {
                delete col.hashDetails;
            }
        });
        MetadataOperationsLogger.info("Got upgraded hash metadata shape", allColumnMetadata);
        return allColumnMetadata;
    }
};
exports.CheckAndUpgradeHashMetadata = CheckAndUpgradeHashMetadata;
const CheckIfNodeHasHashColumns = (columnMetadata) => {
    return columnMetadata.some(column => column.hashDetails);
};
exports.CheckIfNodeHasHashColumns = CheckIfNodeHasHashColumns;
const FormatHashUpdate = (hashColumnCounter, allColumnMetadata, newTabularValue) => {
    const metadataToUse = (0, exports.CheckAndUpgradeHashMetadata)(allColumnMetadata);
    const hashColumnIndex = metadataToUse.findIndex(col => col.columnReference.columnCounter === hashColumnCounter);
    metadataToUse[hashColumnIndex].hashedColumns = newTabularValue;
    return metadataToUse;
};
exports.FormatHashUpdate = FormatHashUpdate;
const GenerateNoLinkRefsFromSQLRunResult = (result) => {
    Common.assert(Logging.LoggingArea.Steps, !!result.runDetails.ref_usage.ref_no_link, `result.runDetails.ref_usage.ref_no_link is undefined`);
    const refsNoLink = result.runDetails.ref_usage.ref_no_link;
    return refsNoLink.map(ref => {
        return { locationName: ref.location_name, nodeName: ref.node_name };
    });
};
exports.GenerateNoLinkRefsFromSQLRunResult = GenerateNoLinkRefsFromSQLRunResult;
const GetStepIDByNameAndStorageLocation = (allSteps, stepName, stepStorageLocation) => {
    const stepIDMatch = Object.keys(allSteps).find(stepID => {
        const stepData = allSteps[stepID];
        const name = Common.getValueSafe(stepData, ["operation", "name"], "");
        const storageLocation = Common.getValueSafe(stepData, ["operation", "locationName"], "");
        const nameMatches = name === stepName;
        const locationMatches = storageLocation === stepStorageLocation;
        return nameMatches && locationMatches;
    });
    return stepIDMatch !== null && stepIDMatch !== void 0 ? stepIDMatch : null;
};
exports.GetStepIDByNameAndStorageLocation = GetStepIDByNameAndStorageLocation;
const GetSingleStepDependenciesSet = (singleStepData) => {
    const sqlType = Common.getValueSafe(singleStepData, ["operation", "sqlType"], null);
    const stepDependenciesStringSet = new Set();
    if (sqlType === Runner.ESQLType.source)
        return stepDependenciesStringSet;
    const sourceMapping = Common.getValueSafe(singleStepData, ["operation", "metadata", "sourceMapping"], null);
    sourceMapping.forEach(sourceMap => {
        sourceMap.dependencies.forEach((dependency) => {
            const { nodeName, locationName } = dependency;
            // set.has does a shallow "===" equality check, so we can't use refLink objects
            const refLinkString = `${nodeName} | ${locationName}`;
            stepDependenciesStringSet.add(refLinkString);
        });
    });
    return stepDependenciesStringSet;
};
const GetStepDependenciesObject = (allSteps) => {
    const stepDependenciesObject = {};
    Object.entries(allSteps).forEach(([stepID, stepData]) => {
        stepDependenciesObject[stepID] = GetSingleStepDependenciesSet(stepData);
    });
    return stepDependenciesObject;
};
exports.GetStepDependenciesObject = GetStepDependenciesObject;
const IsSingleStepDependencySetUnchanged = (previousStateStepDependenciesSet, nextStateStepDependenciesSet) => {
    const areSizesEqual = previousStateStepDependenciesSet.size === nextStateStepDependenciesSet.size;
    if (!areSizesEqual)
        return false;
    for (let refLink of previousStateStepDependenciesSet) {
        if (!nextStateStepDependenciesSet.has(refLink)) {
            return false;
        }
    }
    return true;
};
const AreAllStepDependenciesUnchanged = (previousStateSteps, nextStateSteps) => {
    const previousStateStepDependenciesObject = (0, exports.GetStepDependenciesObject)(previousStateSteps);
    const nextStateStepDependenciesObject = (0, exports.GetStepDependenciesObject)(nextStateSteps);
    const { added, modified, removed } = Common.calculateObjectDifference(previousStateStepDependenciesObject, nextStateStepDependenciesObject, IsSingleStepDependencySetUnchanged);
    return !added.length && !modified.length && !removed.length;
};
exports.AreAllStepDependenciesUnchanged = AreAllStepDependenciesUnchanged;
//////////// END StepDependencies API 
//# sourceMappingURL=StepOperations.js.map